<!DOCTYPE html>
<html>
	<head>
		<title>Hamming Kodu</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="calculationlib/polynomial.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
		</script>
		<style>
		
		#result td {
			text-align: center;
			padding: 5px ;
			border: 1px black solid;
		}
		
		table[id=result] {
			border-collapse: collapse;
			margin-left:auto; 
			margin-right:auto;
			margin-top: 15px;
		}
		
		</style>
	
	</head>
	<body>
		<h3>Hamming Kodu</h3>

		<table> 
		
		<tr>
		<td> <b>q:</b> </td>
		<td> <input type="text" id="txtQ" value="2"/> </tr>
		</tr>
		<tr>
		<td> <b>r:</b> </td>
		<td> <input type="text" id="txtR" value="3"/> </td>
		</tr>
		<tr>
		<td> </td>
		<td> <input type="button" id="btnCalculate" value="Kodu Bul" /> </td>
		</tr>
		
		<tr>
		<td> <b>Üreteç <br />Matris</b> </td>
		<td> <textarea class="form-control" id="txtGenMatrix" rows="5"></textarea> </td>
		</tr>
		
		</table>
		
		
		<!--<input type="text" id="txtGenMatrix" value="" />-->
		<div id="divResult"></div>
		
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnCalculate") {
					
						var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
						var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }
						var randomVector = function(n,q) { 
							var result = []; 
							var sum = 0;
							while (sum == 0) {
								for (var i = 0; i < n; i++) {
									var val = parseInt(Math.random()*(q+1));
									result.push(val);
									sum += val;
								}
							}
							return result;
						}

						
						$("#divResult").html("");
						
						var q = parseInt($('#txtQ').val());
						var r = parseInt($('#txtR').val());
						var n = (Math.pow(q, r) - 1) / (q - 1);
						var k = n - r;
						
						var formulaText = "\\begin{eqnarray*}";
						formulaText += "n &=& \\frac{q^r-1}{q-1} = " + n + " \\\\";
						formulaText += "k &=& n - r = " + k;
						formulaText += "\\end{eqnarray*}";
						AddFormula("divResult", "formula", formulaText);
						$("#divResult").append("<br />");
					
						//var p1 = new Matrix([[2],[1],[2]]);
						//var p2 = new Matrix([[1],[2],[2]]);
						//var g = new MatrixCalculator(3);
						//var t = g.IsScalerMultiplier(p1, p2);
						
						vectors = [];
						var gen = new MatrixGenerator(q);
						var processor = new MatrixCalculator(q);
						for (var i = 0; i < n; i++) {
							var add;
							do {
								add = true;
								var vector;
								do {
									var vector = gen.RandomInt(r, 1, 0, q+1);
									var sum = new MatrixCalculator().Sum(vector);
								} while (sum == 0)
								
								for (var j = 0; j < i; j++) {
									var v = vectors[j];
									var s = processor.IsScalerMultiplier(v, vector);
									if (s == true) {
										add = false;
										break;
									}
								}
							} while(!add)
							
							vectors.push(vector);
						}
						
						var matrix = vectors[0];
						for (var i = 1; i < vectors.length; i++)
							matrix = matrix.AddRight(vectors[i]);
						
						var text = "H=" + matrix.ToLatex(true);
						AddFormula("divResult", "parity_check_matrix", text);
						$("#divResult").append("<br />");
						
						var g = new ErrorCorrectingCode(matrix, q).DualCode();
						text = "G=" + g.Generator.ToLatex(true);
						AddFormula("divResult", "parity_check_matrix2", text);
						$("#divResult").append("<br />");
						
						$("#txtGenMatrix").val(g.Generator.ToString2());
						
						var r = processor.MatrixMultiplication(g.Generator, matrix.Transpose());
						text = "GH^T=" + g.Generator.ToLatex() + matrix.Transpose().ToLatex() + "=" + r.ToLatex(true);
						AddFormula("divResult", "parity_check_matrix3", text);
						
					}
				});
			});
		</script>

	</body>
</html>
